Scriptname GT01SCRPTMilkCow extends ObjectReference  
;
;This script is for milking cows
;==============================================================

Import Game
Import Utility
Import Debug
Import Math

Potion Property MilkPot Auto
{Add milk potion here}

Static Property XMark Auto
{XMarker or static non-collision bucket, must be used to set player direction}

sound property MilkingSound auto
{Find a sound to play once per second while milking}

Idle Property IdleStop_Loose Auto
{Autofill}

MISCOBJECT PROPERTY Bucket AUTO
{Add a bucket to go under the cow}

String Property DaystoWait Auto
{Select amount of days to wait between milking, e.g 1.00, 2.00 etc.}

Int Property HowManyPer Auto
{Seleect amount of milk to be gained per milking, e.g, 1, 2, etc.}

String property FailureMessage auto
{Message that appears when you have already milked this cow}

Float OffsetAngle
Float OffsetDistance 

ObjectReference MilkingBucket
ObjectReference XMarkCrouch 

float property lastHarvestedDay auto Hidden
{the game day this was last successfuly harvested, used to know when to respawn}



;===================================================================
;;STATE BLOCK
;===================================================================

auto state readyForHarvest
	event onActivate(objectReference akActivator)
		goToState("waitingToRespawn")
		fakeHarvest(akActivator)
	endEvent
endState

state waitingToRespawn
	event onBeginState()
		lastHarvestedDay = utility.getCurrentGameTime()
	endEvent

	event onActivate(objectReference akActivator)
		Notification(FailureMessage)
	endEvent

	event onCellLoad()
		Utility.Wait(1.00)
		if (lastHarvestedDay + DaystoWait) <= utility.getCurrentGameTime()
			goToState("readyForHarvest")
		endif
	endEvent
endState

;===================================================================
;;FUNCTION BLOCK
;===================================================================

function fakeHarvest(objectReference akActivator)
	if (akActivator as actor)
Actor Player = Game.GetPlayer()

MilkingBucket = Self.PlaceAtMe(Bucket)
MilkingBucket.SetScale(0.5)
MilkingBucket.MoveTo(Self, -60 * Math.Sin(Self.GetAngleZ()), -60 * Math.Cos(Self.GetAngleZ()), abMatchRotation = true)
Game.ForceThirdPerson()
Game.DisablePlayerControls(abMovement = true, abFighting = false, abCamSwitch = true, abLooking = false, abSneaking = false, abMenu = true, abActivate = false, abJournalTabs = false)
XMarkCrouch = MilkingBucket.PlaceAtMe(XMark)
XMarkCrouch.MoveTo(Self, -60 * Math.Sin(Self.GetAngleZ()), -60 * Math.Cos(Self.GetAngleZ()), abMatchRotation = true)
Utility.Wait(0.5)
Game.SetPlayerAIDriven()
Player.SetLookAt(XMarkCrouch , true)
float AngleZ = XMarkCrouch .GetAngleZ() + OffsetAngle
float OffsetX = OffsetDistance * Math.Sin(AngleZ)
float OffsetY = OffsetDistance * Math.Cos(AngleZ) + 50
Player.MoveTo(XMarkCrouch, 30 * Math.Sin(XMarkCrouch.GetAngleZ()), 30 * Math.Cos(XMarkCrouch.GetAngleZ()), Self .GetHeight() + 15)
Player.SetAngle(XMarkCrouch .GetAngleX(), XMarkCrouch .GetAngleY(), XMarkCrouch .GetAngleZ() + \
 Player.GetHeadingAngle(XMarkCrouch ))
Player.SetLookAt(XMarkCrouch , true)
Utility.wait(1.0)
Debug.SendAnimationEvent(Player, "IdleWarmHandsCrouched")
Utility.wait(1.0)
int instanceID = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID)
Utility.wait(1.0)
int instanceID2 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID2)
Utility.wait(1.0)
int instanceID3 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID3)
Utility.wait(1.0)
int instanceID4 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID4)
Utility.wait(1.0)
Player.AddItem(MilkPot,HowManyPer,true)
Notification(HowManyPer + " Milk Added")
Player.PlayIdle(IdleStop_Loose)
Game.EnablePlayerControls()
MilkingBucket.Delete()
XMarkCrouch.Delete()
Utility.wait(1.0)
Game.ForceFirstPerson()
Game.SetPlayerAIDriven(False)
	endif
endFunction

